<?php

class Pathnode extends CI_Model {

    function __construct()
    {
        parent::__construct();
        $this->t = "nagiosna_path_nodes";
        $this->i = "nagiosna_path_status";
    }

    function create($q)
    {
        $q['created'] = date('Y-m-d h:i:s');
        $q['modified'] = date('Y-m-d h:i:s');
        $success = $this->db->insert($this->t, $q);
        if($success == FALSE) {
            throw new Exception($this->db->_error_message());
        }

        $id = $this->db->insert_id();

        return $id;
    }

    function read_all()
    {
        $query = $this->db->get($this->t);
        return $query->result_array();
    }

    function read_one($id)
    {
        /** Note: I haven't been able to make get_where() work with CI2 + CentOS Stream 8.
         * I didn't try to dig through the CI db helper's source code, but if we find that
         * get_where is working later then it's fine to refactor stuff like this.
         * -swolf 2023-10-26
         */
        $id = intval($id);
        $sql = "SELECT * FROM {$this->t} WHERE id = $id LIMIT 1";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        if (count($result)) {
            return $result[0];
        }
        return null;
    }

    // TODO this should really be in a separate model...
    function read_edges($target_node)
    {
        $target_node = intval($target_node);
        $select_query = "SELECT * FROM {$this->i} WHERE target_node = $target_node";
        $query = $this->db->query($select_query);
        return $query->result_array();
    }

    function update($id, $parameters)
    {
        $id = intval($id);
        if (array_key_exists('ncpa_token', $parameters) && $parameters['ncpa_token'] === '_<unchanged>_')
        {
            unset($parameters['ncpa_token']);
        }

        $modified = $this->db->escape(date('Y-m-d H:i:s'));
        $query = "UPDATE {$this->t} SET modified = $modified";
        foreach ($parameters as $column => $value) {
            $value_safe = $this->db->escape($value);
            $query .= ", $column = $value_safe";
        }
        $query .= " WHERE id = $id";
        $this->db->query($query);
    }

    function update_reachability($id, $reachability)
    {
        $id = intval($id);
        $reachability = intval($reachability);
        $modified = $this->db->escape(date('Y-m-d H:i:s'));
        $node_update_query = "UPDATE {$this->t} 
            SET reachability = $reachability, 
                modified = $modified
            WHERE id = $id";
        $this->db->query($node_update_query);
    }

    function update_position($id, $x, $y)
    {
        $id = $this->db->escape($id);
        $x = $this->db->escape($x);
        $y = $this->db->escape($y);
        $update_query = "UPDATE {$this->t} 
            SET x = $x, 
                y = $y
            WHERE id = $id";
        $result = $this->db->query($update_query);
        return $result;
    }

    function delete($id_array)
    {
        if (!is_array($id_array)) {
            $id_array = array($id_array);
        }

        // "validate". intval() is stronger than $this->db->escape(), so we can skip that here.
        foreach ($id_array as $i => $id) {
            $id = intval($id);
            if ($id == 0 || $id == 1) {
                // Stack overflow says this is safe to do in PHP, they've never lied to me before :^)
                unset($id_array[$i]);
            }
            else {
                $id_array[$i] = $id;
            }
        }
        $id_array = array_unique($id_array);

        // Delete associated checks.
        $this->load->model('Check');
        $checks = $this->Check->read_by_associated_path($id_array);

        $cids = array();
        for ($i = 0; $i < count($checks); $i += 1) {
            $cids[] = $checks[$i]['cid'];
        }

        $this->Check->delete($cids);

        $id_array_safe = implode(',', $id_array);
        $delete_query = "DELETE FROM {$this->t} WHERE id IN ($id_array_safe)";
        $result = $this->db->query($delete_query);
        return $result;
    }
}